Attribute VB_Name = "MODULE2"

Sub HOUSECALC()
    If XSTEP% = 0 Then
        F = NatalTime!: If Int(NatalTime!) = 12 Then F = NatalTime! - 12
        F = (ConvertDMtoDec(F) + NatalTimeZone!) / 24
        If NatalBirthTime$ = "P.M." Then
            F = F + 0.5
        End If
        LO = Abs(NatalLong!)
        LA = Abs(NatalLat!)
        d2$ = NatalD2$
        D = NatalDay%: M = NatalMonth%: Y = NatalYear%
    Else
        F = DiurnalTime!: If Int(DiurnalTime!) = 12 Then F = DiurnalTime! - 12
        F = (ConvertDMtoDec(F) + DiurnalTimeZone!) / 24
        If DiurnalBirthTime$ = "P.M." Then F = F + 0.5
        LO = Abs(DiurnalLong!)
        LA = Abs(DiurnalLat!)
        d2$ = DiurnalD2$
        D = DiurnalDay%: M = DiurnalMonth%: Y = DiurnalYear%
        Diurnal_F = F
        XDAY = D: XMonth = M: XYear = Y
        Call GetJulianDay
    End If

    IM = 12 * (Y + 4800) + M - 3
    J# = (2 * (IM - Int(IM / 12) * 12) + 7 + 365 * IM) / 12
    J# = Int(J#) + D + Int(IM / 48) - 32083
    If J# > 2299171 Then
        J# = (J# + Int(IM / 4800) - Int(IM / 1200) + 38)
        jd = J# + F - 0.5
        If XSTEP% = 0 Then
            NatalJD = jd
        Else
            DiurnalJD = jd
        End If
    End If

    HW1$ = Str$(Y): If Y < 10 Then HW1$ = "0" + Right$(HW1$, 1)
    HW2$ = Str$(z): If z < 10 Then HW2$ = "0" + Right$(HW2$, 1)
    HW3$ = Str$(BK): If BK < 10 Then HW3$ = "0" + Right$(HW3$, 1)
    SiderealTime$ = Right$(HW1$, 2) + "H  " + Right$(HW2$, 2) + "M  " + Right$(HW3$, 2) + "S "
End Sub

' ********** CALCULATION OF WHICH PLANETS ARE IN WHICH HOUSES *****************
Sub PLANETSINHOUSES()
    Dim CorrPlanetsY

    For X = 1 To 12
        For Y = 1 To NumberOfPlanets%
            Mid$(ph$, Y * 10 - 5, 10) = " HOUSE"
            CorrPlanetsY = Planets(Y) + (1 / 36000)
                If X < 12 And HC(X) > HC(X + 1) Then GoTo PIH6
                If X = 12 And HC(X) > HC(1) Then GoTo PIH8
                If CorrPlanetsY >= HC(X) And CorrPlanetsY < HC(X + 1) And X < 12 Then Mid$(ph$, Y * 10 - 9, 4) = Mid$(HCX1$, X * 4 - 3, 4): GoTo PIH9
                If CorrPlanetsY >= HC(X) And CorrPlanetsY < HC(1) And X = 12 Then Mid$(ph$, Y * 10 - 9, 4) = Mid$(HCX1$, X * 4 - 3, 4)
                GoTo PIH9

PIH6:
                If (CorrPlanetsY >= HC(X) And CorrPlanetsY < 360) Or (CorrPlanetsY < HC(X + 1) And CorrPlanetsY >= 0) Then Mid$(ph$, Y * 10 - 9, Y * 10 - 6) = Mid$(HCX1$, X * 4 - 3, 4)
                GoTo PIH9

PIH8:
                If (CorrPlanetsY >= HC(X) And CorrPlanetsY < 360) Or (CorrPlanetsY < HC(1) And CorrPlanetsY >= 0) Then Mid$(ph$, Y * 10 - 9, Y * 10 - 6) = Mid$(HCX1$, X * 4 - 3, 4)
PIH9:
        Next Y
    Next X
End Sub

Sub CalculateAstrology()
        Dim X(6) As Double

        HS$ = "P"

        InputErrorFlag% = 0
        Call CheckInputErrors
        Call CheckLatitudeErrors
        Call CheckOverflowErrorsNatal
        Call CheckOverflowErrorsDiurnal
        If InputErrorFlag% = 1 Then Exit Sub

        Screen.MousePointer = 11
        InputD.Hide: InputD1.Hide: Names.Hide: Geograph.Hide

        NatOrTranOuter% = 0
        ZN$ = InputD!txtName.Text

        Call FetchNatalData
        Call FetchDiurnalData

'do natal calculations
        XSTEP% = 0
        Call HOUSECALC
        NatalST$ = SiderealTime$

        iday% = NatalDay%
        imonth% = NatalMonth%
        iyear% = NatalYear%

        ihour% = Val(InputD!txtBirthHour.Text)
        If InputD!optAM.Value = True Then
            If ihour% = 12 Then
                ihour% = 0
            End If
        Else
            If ihour% <> 12 Then
                ihour% = ihour% + 12
            End If
        End If
        ihour% = ihour% + NatalTimeZone!
        imin% = Val(InputD!txtBirthMinute.Text)

        If NatalD1$ = "East" Then
            lon = Val(InputD!txtLongDeg.Text + InputD!txtLongMin.Text / 60)
        Else
            lon = -Val(InputD!txtLongDeg.Text + InputD!txtLongMin.Text / 60)
        End If

        If NatalD2$ = "North" Then
            lat = Val(InputD!txtLatDeg.Text + InputD!txtLatMin.Text / 60)
        Else
            lat = -Val(InputD!txtLatDeg.Text + InputD!txtLatMin.Text / 60)
        End If

        fetch_ss% = 0
        Call PlanetEquations:   'does house cusps, too

        For X1B% = 1 To 13: NatalHouse(X1B%) = HC(X1B%): Next X1B%

        Planets(12) = CRUNCH(Planets(11) + 180)
        DECL(12) = -DECL(11)

        Call PLANETSINHOUSES
        NatalPH$ = ph$: OuterPH$ = ph$

        Call AngleDeclinations

        For X1B% = 1 To NumberOfPlanets%
            Natal(X1B%) = Planets(X1B%)
            NatalDecl(X1B%) = DECL(X1B%)
            z = Natal(X1B%)
        Next X1B%
        NatalH$ = Retrograde$

'do transit calculations
        XSTEP% = 3: Call HOUSECALC
        TransitST$ = SiderealTime$

        iday% = DiurnalDay%
        imonth% = DiurnalMonth%
        iyear% = DiurnalYear%

        ihour% = Val(InputD1!txtDiurnalHour.Text)
        If InputD1!optDiurnalAM.Value = True Then
            If ihour% = 12 Then
                ihour% = 0
            End If
        Else
            If ihour% <> 12 Then
                ihour% = ihour% + 12
            End If
        End If
        ihour% = ihour% + DiurnalTimeZone!
        imin% = Val(InputD1!txtDiurnalMinute.Text)

        If DiurnalD1$ = "East" Then
            lon = Val(InputD1!txtDiurnalLongDeg.Text + InputD1!txtDiurnalLongMin.Text / 60)
        Else
            lon = -Val(InputD1!txtDiurnalLongDeg.Text + InputD1!txtDiurnalLongMin.Text / 60)
        End If

        If DiurnalD2$ = "North" Then
            lat = Val(InputD1!txtDiurnalLatDeg.Text + InputD1!txtDiurnalLatMin.Text / 60)
        Else
            lat = -Val(InputD1!txtDiurnalLatDeg.Text + InputD1!txtDiurnalLatMin.Text / 60)
        End If

        fetch_ss% = 0
        Call PlanetEquations

        For X1B% = 1 To 13: TransitHouse(X1B%) = HC(X1B%): Next X1B%

        Planets(12) = CRUNCH(Planets(11) + 180)
        DECL(12) = -DECL(11)

        Call PLANETSINHOUSES
        TransitPH$ = ph$

        Call AngleDeclinations

        For X1B% = 1 To NumberOfPlanets%
            Transit(X1B%) = Planets(X1B%)
            TransitDecl(X1B%) = DECL(X1B%)
            z = Transit(X1B%)
        Next X1B%
        TransitH$ = Retrograde$
        h1$ = TransitH$

        EphemDB!mnuData.Visible = True
        EphemDB!mnuInputData.Visible = True

        Call XHeader1
        Call NatalList
        Call TransitList
        For X1B% = 1 To NumberOfPlanets%
            Planets(X1B%) = Natal(X1B%)
            DECL(X1B%) = NatalDecl(X1B%)
        Next X1B%

        Call AdjustForm

        Screen.MousePointer = 0
End Sub

Sub Cart2Sph()
        R = Sqr(X * X + Y * Y + z * z): RHO = Sqr(X * X + Y * Y)
        ZETA = 2 * DEGREES(Atn(Y / (Abs(X) + Sqr(X * X + Y * Y))))
        If RHO = 0 And z > 0 Then BETA = 90: GoTo C2SP1
        If RHO = 0 And z = 0 Then BETA = 0: GoTo C2SP1
        If RHO = 0 And z < 0 Then BETA = -90: GoTo C2SP1
        If RHO <> 0 Then BETA = DEGREES(Atn(z / RHO))
C2SP1:  If X = 0 And Y = 0 Then LAMBDA = 0: GoTo S2C1
        If X >= 0 And Y >= 0 Then LAMBDA = ZETA: GoTo S2C1
        If X >= 0 And Y < 0 Then LAMBDA = ZETA + 360: GoTo S2C1
        If X < 0 Then LAMBDA = 180 - ZETA
S2C1:
End Sub

Sub PlanetEquations()
    Dim T$, Y%, z%
    Dim X(6) As Double
    Dim cusp(13) As Double
    Dim ascmc(10) As Double

    Dim cal As Byte

    H = ihour% + imin% / 60#

 ' the next two functions do the same job, converting a calendar date
 ' into a Julian day number
 ' swe_date_conversion() checks for legal dates while swe_julday() handles
 ' even illegal things like 45 Januar etc.
    cal = 103  ' g for gregorian calendar

    tjd_ut = swe_julday(iyear%, imonth%, iday%, H, 1)
    retval = swe_date_conversion(iyear, imonth, iday, H, cal, tjd_ut)

    tjd_et = tjd_ut
    'tjd_ut = tjd_et - swe_deltat(tjd_et)
    tjd_ut = tjd_et

    For Y% = 0 To 15
        If Y% = 12 Or Y% = 13 Or Y% = 14 Then GoTo pp1
        z% = Y% + 1

        iflag = 258                     'for geo
'sidereal
        'iflag = 258 + 65536       'geo - sidereal

        serr$ = String(255, 0)
        plnam$ = String(20, 0)

        ret_flag = swe_calc(tjd_et, Y%, iflag, X(0), serr$)

        Planets(z%) = X(0)
        SpeedX(z%) = X(3)

        iflag = iflag + 2048
        ret_flag = swe_calc(tjd_et, Y%, iflag, X(0), serr$)

        DECL(z%) = X(1)
pp1:
    Next Y%

    T$ = HS$

'sidereal
    'iflag = 65536
    ret_flag = swe_houses(tjd_ut, lat, lon, Asc(T$), cusp(0), ascmc(0))         'tropical
    'ret_flag = swe_houses_ex(tjd_ut, iflag, lat, lon, Asc(t$), cusp(0), ascmc(0))  'sidereal


    For Y% = 1 To 12
        HC3(Y%) = cusp(Y%)
    Next Y%

    For Y% = 1 To 9
        HC(Y% + 3) = HC3(Y%)
    Next Y%

    For Y% = 10 To 12
        HC(Y% - 9) = HC3(Y%)
    Next Y%

    iflgret = swe_calc(tjd_et, -1, 0, X(0), serr)
    OB = X(0)

    swe_close

    Planets(12) = CRUNCH(Planets(11) + 180)
    Planets(13) = CRUNCH(HC(4) + Planets(2) - Planets(1))
    Planets(14) = HC(4)
    Planets(15) = HC(1)

    Retrograde$ = Space$(NumberOfPlanets%)

    For Y% = 1 To 16
        If SpeedX(Y%) < 0 Then
            Mid$(Retrograde$, Y%, 1) = "R"
        End If
    Next Y%
    
    If fetch_ss% = 0 Then Exit Sub
    
'get sunrise and sunset times
    Dim tret(20) As Double
    Dim geopos(10) As Double
    Dim adj As Double
    
    Const SE_SUN As Integer = 0
    Const SEFLG_SWIEPH As Long = 2
    Const SE_CALC_RISE As Long = 1
    Const SE_CALC_SET As Long = 2
    
    geopos(0) = 0
    geopos(1) = lat
    geopos(2) = 0
    
    adj = ((Abs(DiurnalTimeZone!) * 15 - Abs(lon)) * 4) / 1440     'adjustment in days
        
    If lon > 0 Then
        adj = -adj          'East longitude
    End If
    
'sunrise
    ret_flag = swe_rise_trans(tjd_ut, SE_SUN, "", SEFLG_SWIEPH, SE_CALC_RISE, geopos(0), 1013.25, 10, tret(0), serr$)
    sunrise_time = tret(0) - adj

'sunset
    ret_flag = swe_rise_trans(tjd_ut, SE_SUN, "", SEFLG_SWIEPH, SE_CALC_SET, geopos(0), 1013.25, 10, tret(0), serr$)
    sunset_time = tret(0) - adj
End Sub

