Attribute VB_Name = "Module5"

Public Sub AnalyzeAspectarian()
    Dim a0, a1, a2, a3, B0, B1, B2, B3, D, p1%, p2%, X%, Y%, q1 As String, q1a As Integer, speed1, speed2, time
    Dim sc1, sc2, sd1, sd2, ay1%, ay2%, ay3%, kk1, kk2
    Dim Chg_Sign%(), Chg_Motion%(), a0_X, a1_X, a2_X, a3_X, a1_Y, a2_Y, sc1_X, sc2_X
    Dim ec1, ec2, flag%, t1$

'StatusCode field in db
'1  T-N
'2  T-T
'3  Direction (Change)
'4  Ingress
'5  VOC Moon
'6  New Moon
'7  1st Quarter Moon
'8  Full Moon
'9  Solar eclipse
'10 Lunar eclipse
'11 No aspects today
'12 reserved
'13 available
'14 Place Holder
'15 Holiday
'16 Birthday
'17 Last Quarter Moon
'18 Sunrise
'19 Sunset
'20 Moon Phase Day (0= New Moon to 29)

    If TN_or_TT% = 0 Then
        ay1% = 10: ay2% = 10
    Else
        ay1% = 10: ay2% = 11
    End If

    ReDim Chg_Sign%(11), Chg_Motion%(11)

    Chg_Motion%(1) = 1: Chg_Motion%(2) = 1

    If fetch_ss% = 1 And TN_or_TT% = 1 Then
        'sunrise
        Call swe_revjul(sunrise_time, 1, yy7, mm7, dd7, hh7)
        t1$ = Format$(mm7 & "/" & dd7 & "/" & yy7, "mm/dd/yyyy")
        t1$ = t1$ & " " & Format$(hh7 / 24, "Long Time")
        
        With myRS
            .AddNew
            !Date = t1$
            !planet1 = " "
            !Aspect = " "
            !planet2 = " "
            !StatusCode = 18
            .Update
        End With
        
        'sunset
        Call swe_revjul(sunset_time, 1, yy7, mm7, dd7, hh7)
        t1$ = Format$(mm7 & "/" & dd7 & "/" & yy7, "mm/dd/yyyy")
        t1$ = t1$ & " " & Format$(hh7 / 24, "Long Time")
        
        With myRS
            .AddNew
            !Date = t1$
            !planet1 = " "
            !Aspect = " "
            !planet2 = " "
            !StatusCode = 19
            .Update
        End With
        fetch_ss% = 0
    End If

'XAsp(Hour number, Planet Number) holds planet longitude on the y% hour
    flag% = 0
    For p1% = 1 To ay1%
        If TN_or_TT% = 0 Then
            ay3% = 1
        Else
            ay3% = p1% + 1
        End If
        For p2% = ay3% To ay2%
            For X% = 0 To 23
                Y% = X% + 1
                speed1 = XAsp(Y%, p1%) - XAsp(X%, p1%)
                If speed1 < -20 Then
                    speed1 = speed1 + 360
                ElseIf speed1 > 20 Then
                    speed1 = speed1 - 360
                End If
                If TN_or_TT% = 0 Then
                    speed2 = 0
                Else
                    speed2 = XAsp(Y%, p2%) - XAsp(X%, p2%)
                    If speed2 < -20 Then
                        speed2 = speed2 + 360
                    ElseIf speed1 > 20 Then
                        speed2 = speed2 - 360
                    End If
                End If

'for checking change of sign
                If TN_or_TT% = 0 Then
                    a1_X = XAsp(X%, p1%): a2_X = Natal(p2%): a0_X = a1_X
                Else
                    a1_X = XAsp(X%, p1%): a2_X = XAsp(Y%, p1%): a0_X = a1_X
                End If

                a3_X = XAsp(X% + 1, p1%)

                sc1_X = Int(Int(a1_X) / 30) + 1: a1_Y = a1_X - (sc1_X - 1) * 30
                If Abs(a1_Y) < 5 Then a1_Y = a1_Y + 30

                sc2_X = Int(Int(a3_X) / 30) + 1: a2_Y = a3_X - (sc2_X - 1) * 30
                If Abs(a2_Y) < 5 Then a2_Y = a2_Y + 30
'okay
                If speed1 > speed2 Then
                    a1 = XAsp(X%, p1%)
                    a2 = XAsp(Y%, p1%)
                    If TN_or_TT% = 0 Then
                        B1 = Natal(p2%)
                        B2 = Natal(p2%)
                    Else
                        B1 = XAsp(X%, p2%)
                        B2 = XAsp(Y%, p2%)
                    End If
                Else
                    If TN_or_TT% = 0 Then
                        a1 = Natal(p2%)
                        a2 = Natal(p2%)
                    Else
                        a1 = XAsp(X%, p2%)
                        a2 = XAsp(Y%, p2%)
                    End If
                    B1 = XAsp(X%, p1%)
                    B2 = XAsp(Y%, p1%)
                End If

                a0 = a1: B0 = B1    'save initial values
'reduce positions to 0 - 30 degrees plus sign number
                sc1 = Int(Int(a1) / 30) + 1: a1 = a1 - (sc1 - 1) * 30
                sc2 = Int(Int(a2) / 30) + 1: a2 = a2 - (sc2 - 1) * 30
                sd1 = Int(Int(B1) / 30) + 1: B1 = B1 - (sd1 - 1) * 30
                sd2 = Int(Int(B2) / 30) + 1: B2 = B2 - (sd2 - 1) * 30

'see if first planet has changed signs
                If sc1_X <> sc2_X And Chg_Sign%(p1%) = 0 And TN_or_TT% = 1 Then
                    'change of signs at some time in this hour - the time (in minutes) is:
                    time = 60 * (a1_Y - 30) / (a1_Y - a2_Y)
                    a3 = a0_X + ((time / 60))
                    GoSub Get_time      'get t1$
                    With myRS
                        .AddNew
                        !Date = t1$
                        !planet1 = Left$(MPNames$(p1%), 3)
                        !Aspect = " "
                        !planet2 = Mid$(SX1$, sc2_X * 3 - 2, 3)
                        !StatusCode = 4
                        .Update
                    End With
                    Chg_Sign%(p1%) = 1
                End If

'see if first planet has changed direction of motion
                If Chg_Motion%(p1%) = 0 And TN_or_TT% = 1 Then
                    kk1 = a3_X - a1_X
                    q1 = ""
                    If ((kk1 > -1 And kk1 < 0) Or (kk1 > 358)) And Retro_Direct%(p1%) = 1 Then
                        Retro_Direct%(p1%) = 0   'retrograde now
                        q1 = "R"
                    ElseIf ((kk1 > 0 And kk1 < 1) Or (kk1 < -358)) And Retro_Direct%(p1%) = 0 Then
                        Retro_Direct%(p1%) = 1   'direct now
                        q1 = "D"
                    End If
                    If q1 <> "" Then
                        time = 0
                        Call Find_Rx_Times(X%, p1%, q1)
                        With myRS
                            .AddNew
                            If X% = -1 Then
                                Dim sd33 As Date
                                sd33 = Calendar$
                                sd33 = sd33 - 1
                                !Date = Format$(sd33, "mm/dd/yyyy") & Space(2) & "23:" & Format$(Rx_Time%, "00")
                            Else
                                !Date = Format$(Calendar$, "mm/dd/yyyy") & Space(2) & Format$(X%, "00") & ":" & Format$(Rx_Time%, "00")
                            End If
                            !planet1 = Left$(MPNames$(p1%), 3)
                            !Aspect = q1
                            !planet2 = " "
                            !StatusCode = 3
                            .Update
                        End With
                        Chg_Motion%(p1%) = 1
                    End If
                End If

'make all numbers compatible around 30 degree break
                If a1 > 28 And a2 < 5 And B1 > 28 And B2 < 5 Then
                    a2 = a2 + 30
                    B2 = B2 + 30
                ElseIf a1 > 28 And a2 < 5 And B1 < 5 And B2 > 28 Then
                    a2 = a2 + 30
                    B1 = B1 + 30
                ElseIf a1 > 28 And a2 < 5 And B1 > 28 And B2 > 28 Then
                    a2 = a2 + 30
                ElseIf a1 > 28 And a2 < 5 And B1 < 5 And B2 < 5 Then
                    a2 = a2 + 30
                    B1 = B1 + 30
                    B2 = B2 + 30
                ElseIf a1 < 5 And a2 < 5 And B1 > 28 And B2 < 5 Then
                    a1 = a1 + 30
                    a2 = a2 + 30
                    B2 = B2 + 30
                ElseIf a1 < 5 And a2 > 28 And B1 < 5 And B2 > 28 Then
                    a1 = a1 + 30
                    B1 = B1 + 30
                ElseIf a1 < 5 And a2 < 5 And B1 < 5 And B2 > 28 Then
                    a1 = a1 + 30
                    B1 = B1 + 30
                    B2 = B2 + 30
                ElseIf a1 > 28 And a2 > 28 And B1 < 5 And B2 > 28 Then
                    B1 = B1 + 30
                End If

'now calculate ratio of time
                If a1 <= B1 And a2 >= B2 Then
                    'we have an aspect at some time in this hour - the time (in minutes) is:
                    time = 60 * (a1 - B1) / (B2 - B1 - a2 + a1)
                    If speed1 > speed2 Then
                        a3 = a0 + ((time / 60) * (speed1))
                        B3 = B0 + ((time / 60) * (speed2))
                    Else
                        a3 = a0 + ((time / 60) * (speed2))
                        B3 = B0 + ((time / 60) * (speed1))
                    End If
                    q1a = 0
                    D = Abs(B3 - a3)
                    If D > 180 Then D = 360 - D
                    If D < 1 Then q1a = 1
                    If D > 59 And D < 61 Then q1a = 2
                    If D > 89 And D < 91 Then q1a = 3
                    If D > 119 And D < 121 Then q1a = 4
                    If (D > 179 And D < 181) Then q1a = 5
                    If q1a > 0 Then
                        GoSub Get_time      'get t1$
                        With myRS
                            .AddNew
                            !Date = t1$
                            !planet1 = Left$(MPNames$(p1%), 3)
                            !Aspect = Mid$(AAX1$, (q1a + 1) * 12 - 11, 3)
                            !planet2 = Left$(MPNames$(p2%), 3)
                            !StatusCode = TN_or_TT% + 1
                            .Update
                        End With

                        If TN_or_TT% = 1 Then
                            If (p1% = 1 And p2% = 2) Or (p1% = 2 And p2% = 1) Then
                                If q1a = 1 Then
                                    MoonPhase% = 0
                                    With myRS
                                        !StatusCode = 6     'new moon
                                        .Update
                                    End With
                                    ec1 = XAsp(X%, 11) 'get Nodes position at start of hour
                                    ec2 = Abs(a3 - ec1)
                                    If ec2 < 18.5167 Or (ec2 > 161.4833 And ec2 < 198.5167) Then
                                        MoonPhase% = 0
                                        With myRS
                                            !StatusCode = 9     'solar eclipse
                                            .Update
                                        End With
                                    End If
                                ElseIf q1a = 3 Then
                                    If (a3 - B3 < 180 And a3 - B3 > 0) Or a3 - B3 < -180 Then
                                        MoonPhase% = 7
                                        With myRS
                                            !StatusCode = 7      '1st quarter moon
                                            .Update
                                        End With
                                    Else
                                        MoonPhase% = 21
                                        With myRS
                                            !StatusCode = 17      'last quarter moon
                                            .Update
                                        End With
                                    End If
                                ElseIf q1a = 5 Then
                                    MoonPhase% = 14
                                    With myRS
                                        !StatusCode = 8     'full moon
                                        .Update
                                    End With
                                    ec1 = XAsp(X%, 11) 'get Nodes position at start of hour
                                    ec2 = Abs(a3 - ec1)
                                    If ec2 < 12.25 Or (ec2 > 167.75 And ec2 < 192.25) Or ec2 > 347.75 Then
                                        MoonPhase% = 14
                                        With myRS
                                            !StatusCode = 10        'lunar eclipse
                                            .Update
                                        End With
                                    End If
                                End If
                            End If
                        End If
                    End If
                End If
AA3:     Next X%
aa2:    Next p2%
aa1:
    Next p1%

'if no aspects occur for a day, then note accordingly
    If flag% = 0 Then
        X% = 12: time = 0       'set 12 noon
        GoSub Get_time      'get t1$
        With myRS
            .AddNew
            !Date = t1$
            !planet1 = " "
            !Aspect = "none"
            !planet2 = " "
            !StatusCode = 11
            .Update
        End With
    End If
            
'mark Moon phase day
    With myRS
        .AddNew
        !Date = t1$
        !planet1 = " "
        !Aspect = Trim$(Str$(MoonPhase%))
        !planet2 = " "
        !StatusCode = 20
        .Update
    End With
    If MoonPhase% > -1 Then
        MoonPhase% = MoonPhase% + 1
    End If
    
    Exit Sub

Get_time:
    flag% = 1
    If Val(Format$(time, "00")) = 60 Then
        If X% < 23 Then
            Buffer = Format$(Calendar$, "mm/dd/yyyy") & Space(2) & Format$(X% + 1, "00") & ":00"
        Else
            Buffer = Format$(Calendar$, "mm/dd/yyyy") & Space(2) & Format$(X%, "00") & ":59"
        End If
    Else
        Buffer = Format$(Calendar$, "mm/dd/yyyy") & Space(2) & Format$(X%, "00") & ":" & Format$(time, "00")
    End If
    t1$ = Buffer
    Return
End Sub


